/*
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

#include "AppWindowBackend.h"
#include "evalyte-cpp-common/config.h"
#include "mirai-core/Config.h"
#include "mirai-core/DataProvider.h"
#include "mirai-core/MarkdownDataProvider.h"
#include "mirai-core/Mirai.h"
#include <cstdlib>
#include <memory>
#include <string>

int main(int argc, char **argv)
{
	mirai::Mirai mirai;

	const auto configFilePath = evalyte::createConfigDirectoryPath("mirai") + "/config.json";
	mirai::Config config(configFilePath);
	for (const auto &sourceFilePath : config.sources()) {
		std::unique_ptr<mirai::DataProvider> file =
			std::make_unique<mirai::MarkdownDataProvider>(sourceFilePath);
		mirai.loadSource(std::move(file));
	}

	AppWindowBackend appWindow{&mirai};
	appWindow.run();

	return 0;
}
